/*
 * Copyright (c) 2012-2014 Wind River Systems, Inc.
 *
 * SPDX-License-Identifier: Apache-2.0
 */

#include <zephyr/kernel.h>
#include <stdio.h>
#include <zephyr/logging/log.h>
#include <zephyr/drivers/i2c.h>

#define LOG_MODULE_NAME app
LOG_MODULE_REGISTER(LOG_MODULE_NAME);

//#define I2C1_NODE DT_NODELABEL(i2c1)
//#define I2C_NODE "I2C_1"
#define I2C_DEV DT_NODELABEL(i2cdev)
const struct device *const i2c_1 = DEVICE_DT_GET(DT_BUS(I2C_DEV));

//struct i2c_dt_spec my_i2c = I2C_DT_SPEC_GET(I2C1_NODE);
//struct i2c_dt_spec my_i2c =(I2C1_NODE);
//static const struct i2c_dt_spec dev_i2c = I2C_DT_SPEC_GET(I2C1_NODE);
void test_i2c(void);


void test_i2c_fn(void)
{
    for (;;) {
        test_i2c();
        k_sleep(K_MSEC(100));
    }
}

void test_i2c(void)
{
    int ret;
    const struct device *i2c_dev;
    i2c_dev = i2c_1;
    if (!i2c_dev) {
        LOG_ERR("I2C Device not found");
    }
    i2c_configure(i2c_dev, I2C_SPEED_SET(I2C_SPEED_STANDARD));

    for (int i=4; i<0x77; i++)
    {
        struct i2c_msg msgs[1];
        uint8_t dst = 1;

        /* Send the address to read from: */
        msgs[0].buf = &dst;
        msgs[0].len = 1U;
        msgs[0].flags = I2C_MSG_WRITE | I2C_MSG_STOP;

        ret = i2c_transfer(i2c_dev, &msgs[0], 1, i);
        if (ret == 0) {
            LOG_INF("Found device 0x%02x", i);
        }
    }
    LOG_INF("Done");
}

int main(void)
{
	LOG_INF("Hello World! %s\n", CONFIG_BOARD_TARGET);

#if 1
             while (1)
             {
                             k_sleep(K_MSEC(1));
             }
#endif

	return 0;
}

K_THREAD_DEFINE(i2c_test_thread_id, 1024, test_i2c_fn, NULL, NULL,
		NULL, 10, 0, 0);
